(*......................................................................*)
(* MLj - a Standard ML to Java bytecode compiler                        *)
(* Copyright (C) 1999 Persimmon IT Inc.                                 *)
(*                                                                      *)
(* This program is free software; you can redistribute it and/or        *)
(* modify it under the terms of the GNU General Public License          *)
(* as published by the Free Software Foundation; either version 2       *)
(* of the License, or (at your option) any later version.               *)
(*                                                                      *)
(* This program is distributed in the hope that it will be useful,      *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of       *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *)
(* GNU General Public License for more details.                         *)
(*                                                                      *)
(* You should have received a copy of the GNU General Public License    *)
(* along with this program; if not, write to the Free Software          *)
(* Foundation, Inc., 59 Temple Place - Suite 330, Boston,               *)
(* MA 02111-1307, USA.                                                  *)
(*......................................................................*)

(*======================================================================*)
(* Signature for StringBuffer.                     			*)
(*======================================================================*)
signature STRINGBUFFER =
sig

type StringBuffer

val fromString   : string -> StringBuffer
val toString     : StringBuffer -> string
val empty        : unit -> StringBuffer
val emptyWith    : int -> StringBuffer
val appendString : StringBuffer * string -> unit
val appendChar   : StringBuffer * char -> unit
val appendInt64  : StringBuffer * FixedInt.int -> unit
val appendInt32  : StringBuffer * int -> unit

end
